#source("FishTissue-CRD-Contrasts.R",print.eval=TRUE)
#Does anova for FishTissue Data - Answers Exercises 1.15 and 2.13
data<-read.table("Data/FishTissueMass.txt",sep = "",header=T)
Tissue<-as.character(data[,1])
hCG<-as.character(data[,2])
Y<-log(data[,3])
aovdata <- data.frame(Y,Tissue,hCG)
#----------This gives the anova table----------------
summary(aov(Y~Tissue*hCG,data=aovdata))
#----------Main Effect Polynomial Contrasts---------------------
Tmean<-tapply(Y,Tissue,mean)
n<-tapply(Y,Tissue,length)
PC<-contr.poly(4,score=1:4)		#polynomial contrasts
SS1=(sum(Tmean*PC[,1]))^2/sum(PC[,1]^2/n)
SS2=(sum(Tmean*PC[,2]))^2/sum(PC[,2]^2/n)
SS3=(sum(Tmean*PC[,3]))^2/sum(PC[,3]^2/n)
print("----------Tissue SS------------------")
print(round(c(SS1, SS2, SS3, SS1+SS2+SS3),4))
#-----------Tests---------------------------------------------
T1<-SS1/0.70580
T2<-SS2/0.70580
T3<-SS3/0.70580
p1<-pf(T1, 1, 4, ncp=0, lower.tail = F)
p2<-pf(T2, 1, 4, ncp=0, lower.tail = F)
p3<-pf(T3, 1, 4, ncp=0, lower.tail = F)
print("----------Tissue Contrast Tests and p-values------------------")
print(round(c(T1, T2, T3),4))
print(round(c(p1, p2, p3),4))
#-----------Cell means and observation numbers_------
aov1<-subset(aovdata,hCG=="N")
mean1<-tapply(aov1[,1],aov1[,2],mean)
n1<-tapply(aov1[,1],aov1[,2],length)
aov2<-subset(aovdata,hCG=="Y")
mean2<-tapply(aov2[,1],aov2[,2],mean)
n2<-tapply(aov2[,1],aov2[,2],length)
#-----------Interaction Polynomial Contrasts-----------------------
SS1=(sum(mean1*PC[,1]-mean2*PC[,1]))^2/(sum(PC[,1]^2/n1)+sum(PC[,1]^2/n2))
SS2=(sum(mean1*PC[,2]-mean2*PC[,2]))^2/(sum(PC[,2]^2/n1)+sum(PC[,2]^2/n2))
SS3=(sum(mean1*PC[,3]-mean2*PC[,3]))^2/(sum(PC[,3]^2/n1)+sum(PC[,3]^2/n2))
print("----------Interaction SS------------------")
print(round(c(SS1, SS2, SS3, SS1+SS2+SS3),4))
#-----------Tests---------------------------------------------
T1<-SS1/0.70580
T2<-SS2/0.70580
T3<-SS3/0.70580
p1<-pf(T1, 1, 4, ncp=0, lower.tail = F)
p2<-pf(T2, 1, 4, ncp=0, lower.tail = F)
p3<-pf(T3, 1, 4, ncp=0, lower.tail = F)
print("----------Interaction Contrast Tests and p-values------------------")
print(round(c(T1, T2, T3),4))
print(round(c(p1, p2, p3),4))
