##################################################################################
##########################Does randomization tests for Miscellanea################
##################################################################################
####################Does a Bunch - Do one at a time###############################
##################################################################################
data<-read.table("Data/Randomization.txt",sep = "",header=T)
Block<-as.character(data[,1])
Trt<-as.character(data[,2])
Y<-data[,3]
aovdata <- data.frame(Block,Trt,Y)
#---------------The oneway on the data-----------------------------
summary(aov(Y~Trt,data=aovdata))
mY<-mean(Y)
m<-1000	#Number of Permutations
Fstat<-array(0,dim=c(m,1))
##################################################################################
#------------------First do the CRD randomization test----------
##################################################################################
aovdata=data.frame(Y,Trt)
CRDaov=summary(aov(Y ~ Trt, data=aovdata))
Fdata=CRDaov[[1]][[4]][[1]]
for(i in 1:m)
{  
	Yp<-sample(Y)
  	aovdata=data.frame(Yp,Trt)
	CRDaov=summary(aov(Yp ~ Trt, data=aovdata))
	Fstat[i]=CRDaov[[1]][[4]][[1]]
}
hist(Fstat,breaks=50,col="grey",main="",xlab="F-ratio",ylab="Relative Frequency",freq=F,xlim=c(0,10))
text(Fdata,.1,expression("Observed F"))
arrows(Fdata,.075,Fdata,0,length=.1,lwd=2)
print(c("p-value=",mean(Fstat>Fdata)))
##################################################################################
#------------------RCB Anova--------------------------
##################################################################################
Fstat2<-array(0,dim=c(m,1))
aovdata=data.frame(Y,Trt,Block)
RCBaov=summary(aov(Y ~ Block+Trt, data=aovdata))
Fdata2=RCBaov[[1]][[4]][[2]]
for(i in 1:m)
{
	Yp=c(sample(Y[Block==1]),sample(Y[Block==2]),sample(Y[Block==3]),sample(Y[Block==4]))
	aovdata=data.frame(Yp,Trt,Block)
	RCBaov=summary(aov(Yp ~ Block+Trt, data=aovdata))
	Fstat2[i]=RCBaov[[1]][[4]][[2]]
}
hist(Fstat2,breaks=50,col="grey",main="",xlab="F-ratio",ylab="Relative Frequency",freq=F,xlim=c(0,10))
text(Fdata2,.1,expression("Observed F"))
arrows(Fdata2,.075,Fdata2,0,length=.1,lwd=2)
print(c("p-value=", mean(Fstat>Fdata)))
##################################################################################
#-------------Side-by-Side---------------------------------------------
##################################################################################
par(mfrow=c(1,2))
hist(Fstat,breaks=50,col="grey",main="",xlab="F-ratio",ylab="Relative Frequency",freq=F,xlim=c(0,10))
text(Fdata,.1,expression("Observed F"))
arrows(Fdata,.075,Fdata,0,length=.1,lwd=2)
hist(Fstat2,breaks=50,col="grey",main="",xlab="F-ratio",ylab="Relative Frequency",freq=F,xlim=c(0,10))
text(Fdata2,.1,expression("Observed F"))
arrows(Fdata2,.075,Fdata2,0,length=.1,lwd=2)
print(c("P-value=", mean(Fstat2>Fdata2)))
##################################################################################
######################Simple Bootstrap/Permutation Demonstration##################
##################################################################################
B=5000
Xboot=array(0,dim=c(B,1))
Xvar=array(0,dim=c(B,1))
n=25
Xdata=rnorm(n)
#Xdata=rgamma(n,shape=1/2,scale=5)
for(i in 1:B)
{
	boot=sample(Xdata,n,replace=T)
	Xboot[i]=mean(boot)
	Xvar[i]=var(boot)
}
par(mfrow=c(1,2))
hist(Xboot,breaks=50,col="grey",main="",xlab="Mean",ylab="Relative Frequency",freq=F)
hist(Xvar,breaks=50,col="grey",main="",xlab="Variance",ylab="Relative Frequency",freq=F)
##################################################################################
#---------------------Oneway anova nonparametric bootstrap------------------------
##################################################################################
m<-1000	#Number of Permutations
Fstat<-array(0,dim=c(m,1))
data<-read.table("Randomization.txt",sep = "",header=T)
Block<-as.character(data[,1])
Trt<-as.character(data[,2])
Y<-data[,3]
aovdata=data.frame(Y,Trt)
CRDaov=summary(aov(Y ~ Trt, data=aovdata))
Fdata=CRDaov[[1]][[4]][[1]]
for(i in 1:m)
{  
	#Yp<-sample(Y)						#Permutation
	Yp<-sample(Y,length(Y),replace=T)	#Bootstrap
  	aovdata=data.frame(Yp,Trt)
	CRDaov=summary(aov(Yp ~ Trt, data=aovdata))
	Fstat[i]=CRDaov[[1]][[4]][[1]]
  	#Yi<-tapply(Yp,Trt,mean)
  	#Fstat[i]<-(9*4*sum((Yi-mY)^2))/(2*sum((Yp-rep(Yi,times=4))^2))
}
hist(Fstat,breaks=50,col="grey",main="",xlab="F-ratio",ylab="Relative Frequency",freq=F,xlim=c(0,10))
text(Fdata,.1,expression("Observed F"))
arrows(Fdata,.075,Fdata,0,length=.1,lwd=2)
print(c("p-value=", mean(Fstat>Fdata)))
##################################################################################
#----------Bootstrap Regression on the residuals----------------------------------
##################################################################################
n=10
B=500
a0=1;b0=3;
Xdata=runif(n,min=-5,max=5)
Ydata=a0+b0*Xdata+rnorm(n,mean=0,sd=2)
plot(Xdata,Ydata,pch=19)
RegFit=summary(lm(Ydata~Xdata))
print(RegFit)
ahat=RegFit$coefficients[1]
bhat=RegFit$coefficients[2]
epsilon=RegFit$residuals
lines(Xdata,ahat+bhat*Xdata,lwd=2)
#------------------------Now we Bootstrap--------------------------------------------------
for(i in 1:B)
{
	Yboot=ahat+bhat*Xdata+sample(epsilon,replace=T)
	RegBoot=summary(lm(Yboot~Xdata))
	lines(Xdata, RegBoot$coefficients[1]+RegBoot$coefficients[2]*Xdata,lwd=2,col="gray")
}
points(Xdata,Ydata,pch=19)
lines(Xdata,ahat+bhat*Xdata,lwd=2)
#------------------------Slope Estimate----------------------------------------------------
slope=array(0,dim=c(B,1))
for(i in 1:B)
{
	Yboot=ahat+bhat*Xdata+sample(epsilon,replace=T)
	RegBoot=summary(lm(Yboot~Xdata))
	slope[i]=RegBoot$coefficients[2]
	}
hist(slope,breaks=50,col="grey",main="",xlab="Slope Estimate",ylab="Relative Frequency",freq=F,xlim=c(0,10))
mean(slope>bhat)

